with Ada.Text_IO;  use Ada.Text_IO;
with Global; use Global;
with Allocation; use Allocation;
procedure Main is
	-- Global.N : constant := 50; -- number of clients
	-- type Id is mod N;
	-- Global.R : constant := 10; -- number of cycle per client
	AllFinished : Boolean := False; -- simulation end
  
   -- signalling simulation end
   protected Terminated is
		procedure Set;
		entry Done;
   private
	 Count : Integer := 0;
   end Terminated;
   protected body Terminated is
		procedure Set is
		begin
			Count := Count + 1;
		end Set;
		entry Done when Count >= N is
		begin	
			null;
		end Done;
   end Terminated;

   task type Client is
	  entry Start(Name: in Id);
   end Client;

   task body Client is
	  Self : Id;
	  NbResources : Integer := 5;
   begin
      accept Start(Name : in Id) do Self := Name; end Start;
	  for I in 1.. R loop
         delay(0.01);  -- Phase1(Self); 
         Allocation.Request(NbResources, Self);
         delay(0.01); -- Phase2(Self);
         Allocation.Release(NbResources, Self);
      end loop;
	  Terminated.Set;
	  -- the last finishing philosopher stops the simulation
   end Client;

   Clients : array (Id) of Client;

begin
   For I in Id loop Clients(I).Start(I); end loop;
   Terminated.Done; 
   Put_Line("   ***** number of times threads are in monitor queue: " & Integer'Image(Allocation.WaitCount)); 
   Put_Line("   ***** number of times threads are in Participation condition queue: " & Integer'Image(Allocation.ParticipationCount));
   Put_Line("   ***** number of times threads are in grant condition queue: " & Integer'Image(Allocation.GrantCount));
end Main;
