package Global is
   N : constant := 5; -- number of philosophers
   type Id is mod N;

	--------------------------------------------------------------
	-- Next_Hazard provides a random number generator with safe concurrent use
	---------------------------------------------------------------

	function Next_Hazard return Float;

	----------------------------------------------------------------------------		
	-- Display_Lock provides mutual exclusion for text displaying on console
	-- allows to print lines of text correctly while concurrent requests are posted
	-----------------------------------------------------------------------------
	
	package Display_Lock is
      procedure Acquire;
      procedure Release;
	end Display_Lock;

end Global;

