public final class Chop {

	private int N ;
	private boolean available [ ] ;
	private boolean requestor [] ;

	Chop (int N) {
		this.N = N ;
		this.available = new boolean[N] ;
		this.requestor = new boolean[N] ;
		for (int i =0 ; i < N ; i++) {
			available[i] = true ; // non allocated stick
			requestor[i] = false; // booking philosopher
		}
	}

	public synchronized void get_LR (int me) {
		while (requestor[(me + 1)% N] && requestor[(me + N - 1)% N] ) {
			try { wait() ; } catch (InterruptedException e) {}
		}
		while ( !available[me] || !available[(me + 1)% N] || requestor[(me + N - 1)% N] ) {
			try { requestor[me] = true ; wait() ; } catch (InterruptedException e) {}
		}
		available[me] = false ; // left stick allocated
        available[(me + 1)% N] = false ; // right stick allocated
        requestor[me] = false ;
	}

	public synchronized void release (int me) {
		available[me] = true ; available[(me + 1)% N] = true ;
		notifyAll() ;
	}
}

// SAFE because of a fairness attempt with requestor
// absence of deadlock due to circular waiting with requestor
// since a releasing philosopher which has both neighbours waiting
// is not able to request
// the fairness has to be proven