public final class Resource {

	private int Max ; // Number of resources
	private int stock ; // Current number of non allocated resources
	private boolean requested = false;

	Resource (int Max) {
		this.Max = Max ;
		this.stock = Max;
	}

	public synchronized void request(int number) {
		while ( requested ){
			try { wait() ; } catch (InterruptedException e) {}
		}
		requested = true;
		stock -= number; // new value of stock, may be negative
		while (stock < 0) {
			try { wait() ; } catch (InterruptedException e) {}
		}
		
        requested = false;	
	}

	public synchronized void release (int number) {
		stock += number ;
		if (stock >= 0) notifyAll() ;
	}
}

// The first requesting thread is served first
// either it receives its requested number at first call
// or once signalled it will be the sole allowed to proceed when calling request anew
// other callers access is denied by requested and queued again
