import java.util.Random;

class Client extends Thread {
    private static Random rand = new Random();
    private static int counter = 1;
    private int number = counter++;
    private Resource resource;
    private int sleepingDurationFactor = 0;
    private int maxTimes = 0;
    private int numberOfRessources = 0;

    public Client(Resource resource, int sleepingDurationFactor, int maxTimes, int numberOfRessources) {
	this.resource = resource;
	this.sleepingDurationFactor = sleepingDurationFactor;
	this.maxTimes = maxTimes;
	this.numberOfRessources = numberOfRessources;
	start();
    }
    
    public void thinking() {
	System.out.println(this + " is thinking");
	if(sleepingDurationFactor > 0)
	    try {
		sleep(rand.nextInt(sleepingDurationFactor));
	    } catch(InterruptedException e) {
		throw new RuntimeException(e);
	    }
	System.out.println(this + " is hungry");
    }
    public void eating() {
	System.out.println(this + " is eating");
	if(sleepingDurationFactor > 0)
	    try {
		sleep(rand.nextInt(sleepingDurationFactor));
	    } catch(InterruptedException e) {
		throw new RuntimeException(e);
	    }
	System.out.println(this + " has finished eating");
    }
    public void quitting() {
	System.out.println(this + " has released its resources");
	if(sleepingDurationFactor > 0)
	    try {
		sleep(rand.nextInt(sleepingDurationFactor));
	    } catch(InterruptedException e) {
		throw new RuntimeException(e);
	    }
    }
    public String toString() {
	return "Client " + number;
    }
    public void run() {
	int i = 0;
	while(i++ < maxTimes) {
	    thinking();
	    resource.request((number + i) % numberOfRessources);
		eating();
		resource.release((number + i) % numberOfRessources);
	    quitting();
	}
    }
}

public class Supper {
    public static void main(String[] args) {
	if(args.length < 1) {
	    System.err.println("usage:\n" +
			       "java Supper numberOfClients sleepingDurationFactor maxTimes numberOfRessources\n" +
			       "A nonzero sleepingDurationFactor will generate a random sleep time during thinking() and eating()\n" +
			       "maxTimes is the maximum number of meals for each client.\n" +
			       "numberOfRessources .\n"
			       );
	    System.exit(1);
	}
	int numberOfRessources = 10;
	int numberOfClients = 5;
	int maxTimes = 100;
	if ( args.length > 0 ) numberOfClients = Integer.parseInt(args[0]);
	Client[] client =
	    new Client[numberOfClients];
	int sleepingDurationFactor = 0;
	if ( args.length > 1 ) sleepingDurationFactor = Integer.parseInt(args[1]);
	if ( args.length > 2 ) maxTimes = Integer.parseInt(args[2]);
	if ( args.length > 3 ) numberOfRessources = Integer.parseInt(args[3]);
	Resource resource = new Resource(numberOfRessources);
	int i = 0;
	while(i < client.length) {
	    client[i++] =
		new Client(resource, sleepingDurationFactor, maxTimes, numberOfRessources);
	}
    }
}
