-- Rveil Prioritaire java1  sans precaution additionnelle
procedure Dining_Philosophers is

   type Id is range 0..4;
   type SticState is array(Id) of Boolean;
   type Cardinal is range 0.. 2;


   protected type Sticks_Type is
      procedure Init;
      entry Get_LR
        (C    : in     Id;
         Done : in out Boolean);
      procedure Release
        (C : in Id);
   private
      entry Wait
        (C    : in     Id;
         Done : in out Boolean);
      Available : SticState;
      Requestor : SticState;
      NotifyAll : Boolean := False;
      StillToNotify : Integer := 0;
   end Sticks_Type;
   Sticks : Sticks_Type;
   protected body Sticks_Type is
      procedure Init is
      begin
         for I in Id loop
            Available(I) := True; Requestor(I) := false;
         end loop;
      end;
      entry Get_LR(C    : in     Id;
                   Done : in out Boolean) when not NotifyAll is
      begin
         if
           Available (C) and Available ((C + 1) mod 5) and
           not Requestor((C + 4) mod 5)
         then
            Available (C) := False;
            Available ((C + 1) mod 5) := False;
            Done := True;
            Requestor(C) := False;
         else
            Requestor(C) := True;
            Done := False;
            requeue Wait;
         end if;
      end Get_LR;
      entry Wait
        (C    : in     Id;
         Done : in out Boolean) when NotifyAll is
      begin
         StillToNotify := StillToNotify - 1;
         NotifyAll := StillToNotify > 0;
         requeue Get_LR;
      end Wait;
      procedure Release(C : Id) is
      begin
         Available(C) := True;
         Available((C + 1) mod 5) := True;
         StillToNotify := Wait'Count;
         NotifyAll := StillToNotify > 0;
      end Release;
   end Sticks_Type;


   procedure Get_LR
     (C : in Id) is
      OK : Boolean := False;
   begin
      while not OK loop
         Sticks.Get_LR(C, OK);
      end loop;
   end Get_LR;


   task type Philosopher is
      entry GetId
        (Get_Unique : in Id);
   end Philosopher;
   task body Philosopher is
      Self : Id ;
   begin
      accept GetId
        (Get_Unique : in Id) do
         Self := Get_Unique;
      end GetId;
      loop
         Get_LR(Self);
         Sticks.Release(Self);
      end loop;
   end Philosopher;
   P0 : Philosopher;
   P1 : Philosopher;
   P2 : Philosopher;
   P3 : Philosopher;
   P4 : Philosopher;

begin
   Sticks.Init;
   P0.Getid(0);
   P1.Getid(1);
   P2.Getid(2);
   P3.Getid(3);
   P4.Getid(4);
end;
